<?php

declare(strict_types=1);

namespace App\Services\WorkingDays\PublicHolidays;

use App\Models\NonWorkingDays;

/**
 * Storage for storing public holidays in persistent storage.
 */
interface PublicHolidaysStateStorageInterface
{
    /**
     * Store a public holiday in the storage.
     * @param \DateTimeImmutable $publicHolidayDate
     * @return NonWorkingDays|null
     */
    public function storePublicHoliday(\DateTimeImmutable $publicHolidayDate): ?NonWorkingDays;
}
