#!/usr/bin/env sh

set -ex


docker compose build

if [ ! -f .env ]; then
    echo "creating new env file"
    cp .env.example .env
else
    echo "env file exists ... ignoring copy"
fi

# composer
docker compose run -it php-fpm composer install

# database
docker compose run -it php-fpm /var/www/html/artisan migrate
docker compose run -it php-fpm /var/www/html/artisan db:seed CountrySeeder

# laravel Swagger
docker compose run -it php-fpm /var/www/html/artisan l5-swagger:generate

# fix permissions (TODO: fix-me)
docker compose run -it php-fpm /bin/sh -c "chown -R www-data:www-data /var/www/html/storage && find /var/www/html/storage -type d -exec chmod 775 '{}' ';' && if [ -d /var/www/html/bootstrap/cache ]; then find /var/www/html/bootstrap/cache -not -name '.gitignore' -exec chmod 777 '{}' ';'; fi"

# run containers (and build again)
if [ "$NO_EXECUTE" != "1" ]; then
  docker compose up --build
fi
