<?php

declare(strict_types=1);

namespace Tests\Unit\Services\WorkingDays\PublicHolidays\Generator;

use App\Services\WorkingDays\PublicHolidays\Generator\PublicHolidaysCzechGenerator;
use PHPUnit\Framework\TestCase;

class PublicHolidaysCzechGeneratorTest extends TestCase
{
    public function testCzechPublicHolidays(): void
    {
        $czechNWD = new PublicHolidaysCzechGenerator();
        // generate non-working days for 2025 and assert the results
        $czechNWD = $czechNWD->generatePublicHolidaysForYear(2025);
        $this->assertEquals([
            new \DateTimeImmutable("2025-01-01"),
            new \DateTimeImmutable("2025-04-18"),
            new \DateTimeImmutable("2025-04-21"),
            new \DateTimeImmutable("2025-05-01"),
            new \DateTimeImmutable("2025-05-08"),
            new \DateTimeImmutable("2025-07-05"),
            new \DateTimeImmutable("2025-07-06"),
            new \DateTimeImmutable("2025-09-28"),
            new \DateTimeImmutable("2025-10-28"),
            new \DateTimeImmutable("2025-11-17"),
            new \DateTimeImmutable("2025-12-24"),
            new \DateTimeImmutable("2025-12-25"),
            new \DateTimeImmutable("2025-12-26"),
        ], $czechNWD);
    }
}
